;=====================================================================
;Macro definition: swaps contents of W and REG:
SWAPWF  MACRO	REG
	XORWF	REG,F
	XORWF	REG,W
	XORWF	REG,F
	ENDM

;=====================================================================
;Macro definition: swaps contents of two registers:
SWAPFF	MACRO 	ra, rb
	movf	ra,W
	xorwf	rb,W
	xorwf	ra,F
	xorwf	rb,F
	ENDM

;=============================================================
;Macro definition: move literal word into memory (byte order: low,high)
movl16 macro number, address	
	movlw	low (number & 0xFFFF)
	movwf	address	
	movlw	high (number & 0xFFFF)
	movwf	address+1
	endm

;=============================================================
;Macro definition: move word (byte order: low,high)
movm16 macro source, dest	
	movf	source,W
	movwf	dest	
	movf	source+1,W
	movwf	dest+1
	endm	

sbra MACRO Label
  IF (Label-$) <= 0
    IF ($-Label+1) >= 255
      Error "Label too far :" Label
      bra $ ; to maintain code size
    ELSE
      bra    Label
    ENDIF
  ELSE
    IF (Label-$-1) >= 256
      Error "Label too far :" Label
      bra $ ; to maintain code size
    ELSE
      bra    Label
    ENDIF
  ENDIF
 ENDM 