;**********************************************************
;***          ALIC Light Controller EM Version 0.3      ***
;**********************************************************

	radix	dec		;Zahlen ohne Basis-Kennzeichnung: dezimal

#define TRUE 1
#define FALSE 0	

;**************************************************************
;*** Konfigurationsdaten:                                   ***
;**************************************************************
	
#define ALICFILE ALIC_source/test.asm	;ALIC ASM-Sourcefile (Licht-Patterns)

;#define DEBUG_UART

;#define CLOCK	32		;CPU Taktfrequenz (MHz)
#define NCHAN	8		;Anzahl der Ausgangskanle (1..8)
#define NVARS	8		;Anzahl der Steuer-Variablen (excl. RCVAR-Variablen)
#define ACTIVELOW FALSE		;LED-Ausgnge sind invertiert wenn "TRUE"
#define AUXOUTA	B'000000'	;freie RA-Ports = Ausgang wenn "1" (5..0)
#define AUXOUTB	B'00000000'	;freie RB-Ports = Ausgang wenn "1" (7..0)
#define AUXOUTC B'000000'	;freie RC-Ports = Ausgang wenn "1"
				;(GP3 bzw.RA3 ist aber immer ein Eingang!)
#define PWM_PERIOD 1024		;PWM Periodendauer (Microsekunden)
#define PWM_DITHER TRUE		;PWM-Dithering wenn effektive Impulsdauer < 1s 
#define GAMMACORRECT TRUE	;bei FALSE: lineare Steuerung der LED-Leistung
 		
#define RCCHAN	1		;Anzahl RC Eingnge (0, 1 oder 2)
#define RCVAR	8		;Variablen-#: RC-Signal (RC-Input 1, RC-Input2 = RCVAR+1) 
#define RCHYST	1		;Hysterese fr RC-Prozessing (* 8 s)

;fr RC Memory-Switch Funktion: 
#define STARTSW B'00000000'	;Status der Schalter bei Start (Nummer 15..8) 
#define RCPW_HIGH 90		;RC-Impuls Schwellwert (90: ca. 1,7ms)
#define RCPW_LOW 39		;RC-Impuls Schwellwert (39: ca. 1,3ms)
				;(64 = 1,5ms, 1 Schritt = 8 s)
#define MS_LONG	10		;min. Haltezeit des Knppels in der Endstellung 
				;fr 2. Memory-Switch Function
				;(1 Schritt: 1/10 s, max. Wert = 15)

;#define RCV1INIT 60		;optional: Initialisierungswert fr RC Variablen
;#define RCV2INIT 64

#define SERIAL_IN FALSE

;---------------- Ende der Konfigurations-Daten

#define ALICFLASH 0x700		;startadress for user's code (flash!)

 if PWM_PERIOD > 0xFFFF
	error "PWM_PERIOD value too high!"
 endif 
;PWMSCALE is used to scale PWM parameters in order to achieve higher precision
 variable PWMSCALE = 0
 variable temp_var = PWM_PERIOD

 while !(temp_var & 0x8000)
 	variable PWMSCALE = PWMSCALE+1
 	variable temp_var = temp_var << 1
 endw
 if PWMSCALE > 6
	variable PWMSCALE = 6	;limit to 2^-6 (1/64 s)
 endif	
